Index: squid/src/auth/ntlm/auth_ntlm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/auth/ntlm/auth_ntlm.c,v
retrieving revision 1.1.2.35
retrieving revision 1.1.2.36
diff -u -r1.1.2.35 -r1.1.2.36
--- squid/src/auth/ntlm/auth_ntlm.c	9 Feb 2001 17:40:56 -0000	1.1.2.35
+++ squid/src/auth/ntlm/auth_ntlm.c	10 Feb 2001 17:32:49 -0000	1.1.2.36
@@ -304,542 +286,499 @@
  * else.
  */
 void
-authenticateNTLMFixErrorHeader (auth_user_request_t * auth_user_request, HttpReply * rep, http_hdr_type type, request_t * request)
+authenticateNTLMFixErrorHeader(auth_user_request_t * auth_user_request, HttpReply * rep, http_hdr_type type, request_t * request)
 {
-  ntlm_request_t *ntlm_request;
-  if (ntlmConfig->authenticate)
-    {
-      /* New request, no user details */
-      if (auth_user_request == NULL)
-	{
-	  debug (29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
-	  httpHeaderPutStrf (&rep->header, type, "NTLM");
-	  /* drop the connection */
-	  httpHeaderDelByName (&rep->header, "keep-alive");
-	  /* NTLM has problems if the initial connection is not dropped
-	   * I haven't checked the RFC compliance of this hack - RBCollins */
-	  request->flags.proxy_keepalive = 0;
-	}
-      else
-	{
-	  ntlm_request = auth_user_request->scheme_data;
-	  switch (ntlm_request->auth_state)
-	    {
+    ntlm_request_t *ntlm_request;
+    if (ntlmConfig->authenticate) {
+	/* New request, no user details */
+	if (auth_user_request == NULL) {
+	    debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
+	    httpHeaderPutStrf(&rep->header, type, "NTLM");
+	    /* drop the connection */
+	    httpHeaderDelByName(&rep->header, "keep-alive");
+	    /* NTLM has problems if the initial connection is not dropped
+	     * I haven't checked the RFC compliance of this hack - RBCollins */
+	    request->flags.proxy_keepalive = 0;
+	} else {
+	    ntlm_request = auth_user_request->scheme_data;
+	    switch (ntlm_request->auth_state) {
 	    case AUTHENTICATE_STATE_NONE:
-	      debug (29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
-	      httpHeaderPutStrf (&rep->header, type, "NTLM");
-	      /* drop the connection */
-	      httpHeaderDelByName (&rep->header, "keep-alive");
-	      /* NTLM has problems if the initial connection is not dropped
-	       * I haven't checked the RFC compliance of this hack - RBCollins */
-	      request->flags.proxy_keepalive = 0;
-	      break;
+		debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
+		httpHeaderPutStrf(&rep->header, type, "NTLM");
+		/* drop the connection */
+		httpHeaderDelByName(&rep->header, "keep-alive");
+		/* NTLM has problems if the initial connection is not dropped
+		 * I haven't checked the RFC compliance of this hack - RBCollins */
+		request->flags.proxy_keepalive = 0;
+		break;
 	    case AUTHENTICATE_STATE_CHALLENGE:
-	      /* we are 'waiting' for a response */
-	      /* pass the challenge to the client */
-	      debug (29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM %s'\n", type, ntlm_request->authchallenge);
-	      httpHeaderPutStrf (&rep->header, type, "NTLM %s", ntlm_request->authchallenge);
-	      break;
+		/* we are 'waiting' for a response */
+		/* pass the challenge to the client */
+		debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM %s'\n", type, ntlm_request->authchallenge);
+		httpHeaderPutStrf(&rep->header, type, "NTLM %s", ntlm_request->authchallenge);
+		break;
 	    default:
-	      debug (29, 0) ("authenticateNTLMFixErrorHeader: state %d.\n", ntlm_request->auth_state);
-	      fatal ("unexpected state in AuthenticateNTLMFixErrorHeader.\n");
+		debug(29, 0) ("authenticateNTLMFixErrorHeader: state %d.\n", ntlm_request->auth_state);
+		fatal("unexpected state in AuthenticateNTLMFixErrorHeader.\n");
 	    }
 	}
     }
 }
 
 void
-authNTLMRequestFree (ntlm_request_t * ntlm_request)
+authNTLMRequestFree(ntlm_request_t * ntlm_request)
 {
-  if (!ntlm_request)
-    return;
-  if (ntlm_request->ntlmnegotiate)
-    xfree (ntlm_request->ntlmnegotiate);
-  if (ntlm_request->authchallenge)
-    xfree (ntlm_request->authchallenge);
-  if (ntlm_request->ntlmauthenticate)
-    xfree (ntlm_request->ntlmauthenticate);
-  memPoolFree (ntlm_request_pool, ntlm_request);
+    if (!ntlm_request)
+	return;
+    if (ntlm_request->ntlmnegotiate)
+	xfree(ntlm_request->ntlmnegotiate);
+    if (ntlm_request->authchallenge)
+	xfree(ntlm_request->authchallenge);
+    if (ntlm_request->ntlmauthenticate)
+	xfree(ntlm_request->ntlmauthenticate);
+    memPoolFree(ntlm_request_pool, ntlm_request);
 }
 
 void
-authNTLMAURequestFree (auth_user_request_t * auth_user_request)
-{
-  if (auth_user_request->scheme_data)
-    authNTLMRequestFree ((ntlm_request_t *) auth_user_request->scheme_data);
-  auth_user_request->scheme_data = NULL;
+authNTLMAURequestFree(auth_user_request_t * auth_user_request)
+{
+    if (auth_user_request->scheme_data)
+	authNTLMRequestFree((ntlm_request_t *) auth_user_request->scheme_data);
+    auth_user_request->scheme_data = NULL;
 }
 
 void
-authenticateNTLMFreeUser (auth_user_t * auth_user)
-{
-  dlink_node *link, *tmplink;
-  ntlm_user_t *ntlm_user = auth_user->scheme_data;
-  auth_user_hash_pointer *proxy_auth_hash;
-
-  debug (29, 5) ("authenticateNTLMFreeUser: Clearing NTLM scheme data\n");
-  if (ntlm_user->username)
-    xfree (ntlm_user->username);
-  /* were they linked in by one or more proxy-authenticate headers */
-  link = ntlm_user->proxy_auth_list.head;
-  while (link)
-    {
-      debug (29, 9) ("authenticateFreeProxyAuthUser: removing proxy_auth hash entry '%d'\n", link->data);
-      proxy_auth_hash = link->data;
-      tmplink = link;
-      link = link->next;
-      dlinkDelete (tmplink, &ntlm_user->proxy_auth_list);
-      hash_remove_link (proxy_auth_cache, (hash_link *) proxy_auth_hash);
-      /* free the key (usually the proxy_auth header) */
-      xfree (proxy_auth_hash->key);
-      memFree (proxy_auth_hash, MEM_AUTH_USER_HASH);
+authenticateNTLMFreeUser(auth_user_t * auth_user)
+{
+    dlink_node *link, *tmplink;
+    ntlm_user_t *ntlm_user = auth_user->scheme_data;
+    auth_user_hash_pointer *proxy_auth_hash;
+
+    debug(29, 5) ("authenticateNTLMFreeUser: Clearing NTLM scheme data\n");
+    if (ntlm_user->username)
+	xfree(ntlm_user->username);
+    /* were they linked in by one or more proxy-authenticate headers */
+    link = ntlm_user->proxy_auth_list.head;
+    while (link) {
+	debug(29, 9) ("authenticateFreeProxyAuthUser: removing proxy_auth hash entry '%d'\n", link->data);
+	proxy_auth_hash = link->data;
+	tmplink = link;
+	link = link->next;
+	dlinkDelete(tmplink, &ntlm_user->proxy_auth_list);
+	hash_remove_link(proxy_auth_cache, (hash_link *) proxy_auth_hash);
+	/* free the key (usually the proxy_auth header) */
+	xfree(proxy_auth_hash->key);
+	memFree(proxy_auth_hash, MEM_AUTH_USER_HASH);
     }
-  memPoolFree (ntlm_user_pool, ntlm_user);
-  auth_user->scheme_data = NULL;
+    memPoolFree(ntlm_user_pool, ntlm_user);
+    auth_user->scheme_data = NULL;
 }
 
 static stateful_helper_callback_t
-authenticateNTLMHandleplaceholder (void *data, void *lastserver, char *reply)
+authenticateNTLMHandleplaceholder(void *data, void *lastserver, char *reply)
 {
-  authenticateStateData *r = data;
-  stateful_helper_callback_t result = S_HELPER_UNKNOWN;
-  int valid;
-  /* we should only be called for placeholder requests - which have no reply string */
-  assert (reply == NULL);
-  assert (r->auth_user_request);
-  /* standard callback stuff */
-  valid = cbdataValid (r->data);
-  /* call authenticateNTLMStart to retry this request */
-  debug (29, 9) ("authenticateNTLMHandleplaceholder: calling authenticateNTLMStart\n");
-  authenticateNTLMStart (r->auth_user_request, r->handler, r->data);
-  cbdataUnlock (r->data);
-  authenticateStateFree (r);
-  return result;
+    authenticateStateData *r = data;
+    stateful_helper_callback_t result = S_HELPER_UNKNOWN;
+    int valid;
+    /* we should only be called for placeholder requests - which have no reply string */
+    assert(reply == NULL);
+    assert(r->auth_user_request);
+    /* standard callback stuff */
+    valid = cbdataValid(r->data);
+    /* call authenticateNTLMStart to retry this request */
+    debug(29, 9) ("authenticateNTLMHandleplaceholder: calling authenticateNTLMStart\n");
+    authenticateNTLMStart(r->auth_user_request, r->handler, r->data);
+    cbdataUnlock(r->data);
+    authenticateStateFree(r);
+    return result;
 }
 
 static stateful_helper_callback_t
-authenticateNTLMHandleReply (void *data, void *lastserver, char *reply)
+authenticateNTLMHandleReply(void *data, void *lastserver, char *reply)
 {
-  authenticateStateData *r = data;
-  ntlm_helper_state_t *helperstate;
-  int valid;
-  stateful_helper_callback_t result = S_HELPER_UNKNOWN;
-  char *t = NULL;
-  auth_user_request_t *auth_user_request;
-  auth_user_t *auth_user;
-  ntlm_user_t *ntlm_user;
-  ntlm_request_t *ntlm_request;
-  debug (29, 9) ("authenticateNTLMHandleReply: Helper: '%d' {%s}\n", lastserver, reply ? reply : "<NULL>");
-  valid = cbdataValid (r->data);
-  if (valid)
-    {
-      if (reply)
-	{
-	  /* seperate out the useful data */
-	  if (strncasecmp (reply, "TT ", 3) == 0)
-	    {
-	      reply += 3;
-	      /* we have been given a Challenge */
-	      /* we should check we weren't given an empty challenge */
-	      /* copy the challenge to the state data */
-	      helperstate = helperStatefulServerGetData (lastserver);
-	      if (helperstate == NULL)
-		fatal ("lost NTLm helper state! quitting\n");
-	      helperstate->challenge = xstrndup (reply, NTLM_CHALLENGE_SZ + 5);
-	      helperstate->challengeuses = 0;
-	      helperstate->renewed = squid_curtime;
-	      /* and we satisfy the request that happended on the refresh boundary */
-	      /* note this code is now in two places FIXME */
-	      assert (r->auth_user_request != NULL);
-	      assert (r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-	      auth_user_request = r->auth_user_request;
-	      ntlm_request = auth_user_request->scheme_data;
-	      assert (ntlm_request != NULL);
-	      result = S_HELPER_DEFER;
-	      debug (29, 9) ("authenticateNTLMHandleReply: helper '%d'\n", lastserver);
-	      assert (ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE);
-	      ntlm_request->authhelper = lastserver;
-	      ntlm_request->authchallenge = xstrndup (reply, NTLM_CHALLENGE_SZ + 5);
-	    }
-	  else if (strncasecmp (reply, "AF ", 3) == 0)
-	    {
-	      /* we're finished, release the helper */
-	      reply += 3;
-	      assert (r->auth_user_request != NULL);
-	      assert (r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-	      auth_user_request = r->auth_user_request;
-	      assert (auth_user_request->scheme_data != NULL);
-	      ntlm_request = auth_user_request->scheme_data;
-	      auth_user = auth_user_request->auth_user;
-	      ntlm_user = auth_user_request->auth_user->scheme_data;
-	      assert (ntlm_user != NULL);
-	      result = S_HELPER_RELEASE;
-	      /* we only expect OK when finishing the handshake */
-	      assert (ntlm_request->auth_state == AUTHENTICATE_STATE_RESPONSE);
-	      ntlm_user->username = xstrndup (reply, MAX_LOGIN_SZ);
-	      ntlm_request->authhelper = NULL;
-	      auth_user->flags.credentials_ok = 1;	/* login ok */
-	    }
-	  else if (strncasecmp (reply, "NA ", 3) == 0)
-	    {
-	      /* TODO: only work with auth_user here if it exists */
-	      assert (r->auth_user_request != NULL);
-	      assert (r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-	      auth_user_request = r->auth_user_request;
-	      auth_user = auth_user_request->auth_user;
-	      assert (auth_user != NULL);
-	      ntlm_user = auth_user->scheme_data;
-	      ntlm_request = auth_user_request->scheme_data;
-	      assert ((ntlm_user != NULL) && (ntlm_request != NULL));
-	      /* todo: action of Negotiate state on error */
-	      result = S_HELPER_RELEASE;	/*some error has occured. no more requests */
-	      ntlm_request->authhelper = NULL;
-	      auth_user->flags.credentials_ok = 2;	/* Login/Usercode failed */
-	      debug (29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM. Error returned '%s'\n", reply);
-	      ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
-	      if ((t = strchr (reply, ' ')))	/* strip after a space */
-		*t = '\0';
-	    }
-	  else if (strncasecmp (reply, "BH ", 3) == 0)
-	    {
-	      /* TODO kick off a refresh process. This can occur after a YR or after
-	       * a KK. If after a YR release the helper and resubmit the request via 
-	       * Authenticate NTLM start. 
-	       * If after a KK deny the user's request w/ 407 and mark the helper as 
-	       * Needing YR. */
-	      assert (r->auth_user_request != NULL);
-	      assert (r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-	      auth_user_request = r->auth_user_request;
-	      auth_user = auth_user_request->auth_user;
-	      assert (auth_user != NULL);
-	      ntlm_user = auth_user->scheme_data;
-	      ntlm_request = auth_user_request->scheme_data;
-	      assert ((ntlm_user != NULL) && (ntlm_request != NULL));
-	      result = S_HELPER_RELEASE;	/*some error has occured. no more requests for 
-						 * this helper */
-	      helperstate = helperStatefulServerGetData (ntlm_request->authhelper);
-	      ntlm_request->authhelper = NULL;
-	      if (ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE)
-		{
-		  /* The helper broke on YR. It automatically
-		   * resets */
-		  auth_user->flags.credentials_ok = 3;	/* cannot process */
-		  debug (29, 1) ("authenticateNTLMHandleReply: Error obtaining challenge from helper: %d. Error returned '%s'\n", lastserver, reply);
-		  /* mark it for starving */
-		  helperstate->starve = 1;
-		  /* resubmit the request. This helper is currently busy, so we will get
-		   * a different one. */
-		  authenticateNTLMStart (auth_user_request, r->handler, r->data);
-		}
-	      else
-		{
-		  /* the helper broke on a KK */
-		  /* first the standard KK stuff */
-		  auth_user->flags.credentials_ok = 2;	/* Login/Usercode failed */
-		  debug (29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM. Error returned '%s'\n", reply);
-		  ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
-		  if ((t = strchr (reply, ' ')))	/* strip after a space */
+    authenticateStateData *r = data;
+    ntlm_helper_state_t *helperstate;
+    int valid;
+    stateful_helper_callback_t result = S_HELPER_UNKNOWN;
+    char *t = NULL;
+    auth_user_request_t *auth_user_request;
+    auth_user_t *auth_user;
+    ntlm_user_t *ntlm_user;
+    ntlm_request_t *ntlm_request;
+    debug(29, 9) ("authenticateNTLMHandleReply: Helper: '%d' {%s}\n", lastserver, reply ? reply : "<NULL>");
+    valid = cbdataValid(r->data);
+    if (valid) {
+	if (reply) {
+	    /* seperate out the useful data */
+	    if (strncasecmp(reply, "TT ", 3) == 0) {
+		reply += 3;
+		/* we have been given a Challenge */
+		/* we should check we weren't given an empty challenge */
+		/* copy the challenge to the state data */
+		helperstate = helperStatefulServerGetData(lastserver);
+		if (helperstate == NULL)
+		    fatal("lost NTLm helper state! quitting\n");
+		helperstate->challenge = xstrndup(reply, NTLM_CHALLENGE_SZ + 5);
+		helperstate->challengeuses = 0;
+		helperstate->renewed = squid_curtime;
+		/* and we satisfy the request that happended on the refresh boundary */
+		/* note this code is now in two places FIXME */
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		ntlm_request = auth_user_request->scheme_data;
+		assert(ntlm_request != NULL);
+		result = S_HELPER_DEFER;
+		debug(29, 9) ("authenticateNTLMHandleReply: helper '%d'\n", lastserver);
+		assert(ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE);
+		ntlm_request->authhelper = lastserver;
+		ntlm_request->authchallenge = xstrndup(reply, NTLM_CHALLENGE_SZ + 5);
+	    } else if (strncasecmp(reply, "AF ", 3) == 0) {
+		/* we're finished, release the helper */
+		reply += 3;
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		assert(auth_user_request->scheme_data != NULL);
+		ntlm_request = auth_user_request->scheme_data;
+		auth_user = auth_user_request->auth_user;
+		ntlm_user = auth_user_request->auth_user->scheme_data;
+		assert(ntlm_user != NULL);
+		result = S_HELPER_RELEASE;
+		/* we only expect OK when finishing the handshake */
+		assert(ntlm_request->auth_state == AUTHENTICATE_STATE_RESPONSE);
+		ntlm_user->username = xstrndup(reply, MAX_LOGIN_SZ);
+		ntlm_request->authhelper = NULL;
+		auth_user->flags.credentials_ok = 1;	/* login ok */
+	    } else if (strncasecmp(reply, "NA ", 3) == 0) {
+		/* TODO: only work with auth_user here if it exists */
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		auth_user = auth_user_request->auth_user;
+		assert(auth_user != NULL);
+		ntlm_user = auth_user->scheme_data;
+		ntlm_request = auth_user_request->scheme_data;
+		assert((ntlm_user != NULL) && (ntlm_request != NULL));
+		/* todo: action of Negotiate state on error */
+		result = S_HELPER_RELEASE;	/*some error has occured. no more requests */
+		ntlm_request->authhelper = NULL;
+		auth_user->flags.credentials_ok = 2;	/* Login/Usercode failed */
+		debug(29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM. Error returned '%s'\n", reply);
+		ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
+		if ((t = strchr(reply, ' ')))	/* strip after a space */
 		    *t = '\0';
-		  /* now we mark the helper for resetting. */
-		  helperstate->starve = 1;
+	    } else if (strncasecmp(reply, "BH ", 3) == 0) {
+		/* TODO kick off a refresh process. This can occur after a YR or after
+		 * a KK. If after a YR release the helper and resubmit the request via 
+		 * Authenticate NTLM start. 
+		 * If after a KK deny the user's request w/ 407 and mark the helper as 
+		 * Needing YR. */
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		auth_user = auth_user_request->auth_user;
+		assert(auth_user != NULL);
+		ntlm_user = auth_user->scheme_data;
+		ntlm_request = auth_user_request->scheme_data;
+		assert((ntlm_user != NULL) && (ntlm_request != NULL));
+		result = S_HELPER_RELEASE;	/*some error has occured. no more requests for 
+						 * this helper */
+		helperstate = helperStatefulServerGetData(ntlm_request->authhelper);
+		ntlm_request->authhelper = NULL;
+		if (ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE) {
+		    /* The helper broke on YR. It automatically
+		     * resets */
+		    auth_user->flags.credentials_ok = 3;	/* cannot process */
+		    debug(29, 1) ("authenticateNTLMHandleReply: Error obtaining challenge from helper: %d. Error returned '%s'\n", lastserver, reply);
+		    /* mark it for starving */
+		    helperstate->starve = 1;
+		    /* resubmit the request. This helper is currently busy, so we will get
+		     * a different one. */
+		    authenticateNTLMStart(auth_user_request, r->handler, r->data);
+		} else {
+		    /* the helper broke on a KK */
+		    /* first the standard KK stuff */
+		    auth_user->flags.credentials_ok = 2;	/* Login/Usercode failed */
+		    debug(29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM. Error returned '%s'\n", reply);
+		    ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
+		    if ((t = strchr(reply, ' ')))	/* strip after a space */
+			*t = '\0';
+		    /* now we mark the helper for resetting. */
+		    helperstate->starve = 1;
 		}
-	      ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
-	    }
-	  else
-	    {
-	      /* TODO: only work with auth_user here if it exists */
-	      assert (r->auth_user_request != NULL);
-	      assert (r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-	      auth_user_request = r->auth_user_request;
-	      auth_user = auth_user_request->auth_user;
-	      assert (auth_user != NULL);
-	      ntlm_user = auth_user->scheme_data;
-	      ntlm_request = auth_user_request->scheme_data;
-	      assert ((ntlm_user != NULL) && (ntlm_request != NULL));
-	      debug (29, 1) ("authenticateNTLMHandleReply: Unsupported helper response, '%s'\n", reply);
-	      /* restart the authentication process */
-	      ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
-	      auth_user->flags.credentials_ok = 3;	/* cannot process */
-	      ntlm_request->authhelper = NULL;
+		ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
+	    } else {
+		/* TODO: only work with auth_user here if it exists */
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		auth_user = auth_user_request->auth_user;
+		assert(auth_user != NULL);
+		ntlm_user = auth_user->scheme_data;
+		ntlm_request = auth_user_request->scheme_data;
+		assert((ntlm_user != NULL) && (ntlm_request != NULL));
+		debug(29, 1) ("authenticateNTLMHandleReply: Unsupported helper response, '%s'\n", reply);
+		/* restart the authentication process */
+		ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
+		auth_user->flags.credentials_ok = 3;	/* cannot process */
+		ntlm_request->authhelper = NULL;
 	    }
+	} else {
+	    fatal("authenticateNTLMHandleReply: called with no result string\n");
 	}
-      else
-	{
-	  fatal ("authenticateNTLMHandleReply: called with no result string\n");
-	}
-      r->handler (r->data, NULL);
-    }
-  else
-    {
-      debug (29, 1) ("AuthenticateNTLMHandleReply: invalid callback data. Releasing helper '%d'.\n", lastserver);
-      result = S_HELPER_RELEASE;
-    }
-  cbdataUnlock (r->data);
-  authenticateStateFree (r);
-  debug (29, 9) ("NTLM HandleReply, telling stateful helper : %d\n", result);
-  return result;
+	r->handler(r->data, NULL);
+    } else {
+	debug(29, 1) ("AuthenticateNTLMHandleReply: invalid callback data. Releasing helper '%d'.\n", lastserver);
+	result = S_HELPER_RELEASE;
+    }
+    cbdataUnlock(r->data);
+    authenticateStateFree(r);
+    debug(29, 9) ("NTLM HandleReply, telling stateful helper : %d\n", result);
+    return result;
 }
 
 static void
-authenticateNTLMStats (StoreEntry * sentry)
+authenticateNTLMStats(StoreEntry * sentry)
 {
-  storeAppendPrintf (sentry, "NTLM Authenticator Statistics:\n");
-  helperStatefulStats (sentry, ntlmauthenticators);
+    storeAppendPrintf(sentry, "NTLM Authenticator Statistics:\n");
+    helperStatefulStats(sentry, ntlmauthenticators);
 }
 
 /* is a particular challenge still valid ? */
 int
-authenticateNTLMValidChallenge (ntlm_helper_state_t * helperstate)
+authenticateNTLMValidChallenge(ntlm_helper_state_t * helperstate)
 {
-  if (helperstate->challenge == NULL)
-    return 0;
-  return 1;
+    if (helperstate->challenge == NULL)
+	return 0;
+    return 1;
 }
 
 /* does our policy call for changing the challenge now? */
 int
-authenticateNTLMChangeChallenge (ntlm_helper_state_t * helperstate)
+authenticateNTLMChangeChallenge(ntlm_helper_state_t * helperstate)
 {
-  /* don't check for invalid challenges just for expiry choices */
-  /* this is needed because we have to starve the helper until all old
-   * requests have been satisfied */
-  if (!helperstate->renewed)
-    {
-      /* first use, no challenge has been set. Without this check, it will
-         loop forever */
-      debug (29, 5) ("authenticateNTLMChangeChallenge: first use\n");
-      return 0;
-    }
-  if (helperstate->challengeuses > ntlmConfig->challengeuses)
-    {
-      debug (29, 4) ("authenticateNTLMChangeChallenge: Challenge uses (%d) exceeded max uses (%d)\n", helperstate->challengeuses, ntlmConfig->challengeuses);
-      return 1;
-    }
-  if (helperstate->renewed + ntlmConfig->challengelifetime < squid_curtime)
-    {
-      debug (29, 4) ("authenticateNTLMChangeChallenge: Challenge exceeded max lifetime by %d seconds\n", squid_curtime - (helperstate->renewed + ntlmConfig->challengelifetime));
-      return 1;
+    /* don't check for invalid challenges just for expiry choices */
+    /* this is needed because we have to starve the helper until all old
+     * requests have been satisfied */
+    if (!helperstate->renewed) {
+	/* first use, no challenge has been set. Without this check, it will
+	 * loop forever */
+	debug(29, 5) ("authenticateNTLMChangeChallenge: first use\n");
+	return 0;
+    }
+    if (helperstate->challengeuses > ntlmConfig->challengeuses) {
+	debug(29, 4) ("authenticateNTLMChangeChallenge: Challenge uses (%d) exceeded max uses (%d)\n", helperstate->challengeuses, ntlmConfig->challengeuses);
+	return 1;
+    }
+    if (helperstate->renewed + ntlmConfig->challengelifetime < squid_curtime) {
+	debug(29, 4) ("authenticateNTLMChangeChallenge: Challenge exceeded max lifetime by %d seconds\n", squid_curtime - (helperstate->renewed + ntlmConfig->challengelifetime));
+	return 1;
     }
-  debug (29, 6) ("Challenge is to be reused\n");
-  return 0;
+    debug(29, 6) ("Challenge is to be reused\n");
+    return 0;
 }
 
 /* send the initial data to a stateful ntlm authenticator module */
 static void
-authenticateNTLMStart (auth_user_request_t * auth_user_request, RH * handler, void *data)
+authenticateNTLMStart(auth_user_request_t * auth_user_request, RH * handler, void *data)
 {
-  authenticateStateData *r = NULL;
-  helper_stateful_server *server;
-  ntlm_helper_state_t *helperstate;
-  char buf[8192];
-  char *sent_string = NULL;
-  ntlm_user_t *ntlm_user;
-  ntlm_request_t *ntlm_request;
-  auth_user_t *auth_user;
-
-  assert (auth_user_request);
-  auth_user = auth_user_request->auth_user;
-  ntlm_user = auth_user->scheme_data;
-  ntlm_request = auth_user_request->scheme_data;
-  assert (ntlm_user);
-  assert (ntlm_request);
-  assert (handler);
-  assert (data);
-  assert (auth_user->auth_type = AUTH_NTLM);
-  debug (29, 9) ("authenticateNTLMStart: auth state '%d'\n", ntlm_request->auth_state);
-  switch (ntlm_request->auth_state)
-    {
+    authenticateStateData *r = NULL;
+    helper_stateful_server *server;
+    ntlm_helper_state_t *helperstate;
+    char buf[8192];
+    char *sent_string = NULL;
+    ntlm_user_t *ntlm_user;
+    ntlm_request_t *ntlm_request;
+    auth_user_t *auth_user;
+
+    assert(auth_user_request);
+    auth_user = auth_user_request->auth_user;
+    ntlm_user = auth_user->scheme_data;
+    ntlm_request = auth_user_request->scheme_data;
+    assert(ntlm_user);
+    assert(ntlm_request);
+    assert(handler);
+    assert(data);
+    assert(auth_user->auth_type = AUTH_NTLM);
+    debug(29, 9) ("authenticateNTLMStart: auth state '%d'\n", ntlm_request->auth_state);
+    switch (ntlm_request->auth_state) {
     case AUTHENTICATE_STATE_NEGOTIATE:
-      sent_string = xstrdup (ntlm_request->ntlmnegotiate);
-      break;
+	sent_string = xstrdup(ntlm_request->ntlmnegotiate);
+	break;
     case AUTHENTICATE_STATE_RESPONSE:
-      sent_string = xstrdup (ntlm_request->ntlmauthenticate);
-      assert (ntlm_request->authhelper);
-      debug (29, 9) ("authenticateNTLMStart: Asking NTLMauthenticator '%d'.\n", ntlm_request->authhelper);
-      break;
+	sent_string = xstrdup(ntlm_request->ntlmauthenticate);
+	assert(ntlm_request->authhelper);
+	debug(29, 9) ("authenticateNTLMStart: Asking NTLMauthenticator '%d'.\n", ntlm_request->authhelper);
+	break;
     default:
-      fatal ("Invalid authenticate state for NTLMStart");
+	fatal("Invalid authenticate state for NTLMStart");
     }
 
-  while (!xisspace (*sent_string))	/*trim NTLM */
-    sent_string++;
+    while (!xisspace(*sent_string))	/*trim NTLM */
+	sent_string++;
 
-  while (xisspace (*sent_string))	/*trim leading spaces */
-    sent_string++;
+    while (xisspace(*sent_string))	/*trim leading spaces */
+	sent_string++;
 
-  debug (29, 9) ("authenticateNTLMStart: state '%d'\n", ntlm_request->auth_state);
-  debug (29, 9) ("authenticateNTLMStart: '%s'\n", sent_string);
-  if (ntlmConfig->authenticate == NULL)
-    {
-      debug (29, 0) ("authenticateNTLMStart: no NTLM program specified:'%s'\n", sent_string);
-      handler (data, NULL);
-      return;
+    debug(29, 9) ("authenticateNTLMStart: state '%d'\n", ntlm_request->auth_state);
+    debug(29, 9) ("authenticateNTLMStart: '%s'\n", sent_string);
+    if (ntlmConfig->authenticate == NULL) {
+	debug(29, 0) ("authenticateNTLMStart: no NTLM program specified:'%s'\n", sent_string);
+	handler(data, NULL);
+	return;
     }
 #ifdef NTLMHELPPROTOCOLV2
-  r = CBDATA_ALLOC (authenticateStateData, NULL);
-  r->handler = handler;
-  cbdataLock (data);
-  r->data = data;
-  r->auth_user_request = auth_user_request;
-  snprintf (buf, 8192, "%s\n", sent_string);
-  helperStatefulSubmit (ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
-  debug (29, 9) ("authenticateNTLMstart: finished\n");
+    r = CBDATA_ALLOC(authenticateStateData, NULL);
+    r->handler = handler;
+    cbdataLock(data);
+    r->data = data;
+    r->auth_user_request = auth_user_request;
+    snprintf(buf, 8192, "%s\n", sent_string);
+    helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
+    debug(29, 9) ("authenticateNTLMstart: finished\n");
 #else
-  /* this is ugly TODO: move the challenge generation routines to their own function and
-   * tidy the logic up to make use of the efficiency we now have */
-  switch (ntlm_request->auth_state)
-    {
+    /* this is ugly TODO: move the challenge generation routines to their own function and
+     * tidy the logic up to make use of the efficiency we now have */
+    switch (ntlm_request->auth_state) {
     case AUTHENTICATE_STATE_NEGOTIATE:
-      /*  
-       * 1: get a helper server
-       * 2: does it have a challenge?
-       * 3: tell it to get a challenge, or give ntlmauthdone the challenge
-       */
-      server = helperStatefulDefer (ntlmauthenticators);
-      helperstate = server ? helperStatefulServerGetData (server) : NULL;
-      while ((server != NULL) && authenticateNTLMChangeChallenge (helperstate))
-	{
-	  /* flag this helper for challenge changing */
-	  helperstate->starve = 1;
-	  /* and release the deferred request */
-	  helperStatefulReleaseServer (server);
-	  server = helperStatefulDefer (ntlmauthenticators);
-	  if (server != NULL)
-	    helperstate = helperStatefulServerGetData (server);
-	}
-      if (server == NULL)
-	debug (29, 9) ("unable to get a deferred ntlm helper... all helpers are refreshing challenges. Queuing as a placeholder request.\n");
-
-      ntlm_request->authhelper = server;
-      /* tell the log what helper we have been given */
-      debug (29, 9) ("authenticateNTLMStart: helper '%d' assigned\n", server);
-      /* valid challenge? */
-      if ((server == NULL) || !authenticateNTLMValidChallenge (helperstate))
-	{
-	  r = CBDATA_ALLOC (authenticateStateData, NULL);
-	  r->handler = handler;
-	  cbdataLock (data);
-	  r->data = data;
-	  r->auth_user_request = auth_user_request;
-	  if (server == NULL)
-	    {
-	      helperStatefulSubmit (ntlmauthenticators, NULL, authenticateNTLMHandleplaceholder, r, ntlm_request->authhelper);
-	    }
-	  else
-	    {
-	      snprintf (buf, 8192, "YR\n");
-	      helperStatefulSubmit (ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
+	/*  
+	 * 1: get a helper server
+	 * 2: does it have a challenge?
+	 * 3: tell it to get a challenge, or give ntlmauthdone the challenge
+	 */
+	server = helperStatefulDefer(ntlmauthenticators);
+	helperstate = server ? helperStatefulServerGetData(server) : NULL;
+	while ((server != NULL) && authenticateNTLMChangeChallenge(helperstate)) {
+	    /* flag this helper for challenge changing */
+	    helperstate->starve = 1;
+	    /* and release the deferred request */
+	    helperStatefulReleaseServer(server);
+	    server = helperStatefulDefer(ntlmauthenticators);
+	    if (server != NULL)
+		helperstate = helperStatefulServerGetData(server);
+	}
+	if (server == NULL)
+	    debug(29, 9) ("unable to get a deferred ntlm helper... all helpers are refreshing challenges. Queuing as a placeholder request.\n");
+
+	ntlm_request->authhelper = server;
+	/* tell the log what helper we have been given */
+	debug(29, 9) ("authenticateNTLMStart: helper '%d' assigned\n", server);
+	/* valid challenge? */
+	if ((server == NULL) || !authenticateNTLMValidChallenge(helperstate)) {
+	    r = CBDATA_ALLOC(authenticateStateData, NULL);
+	    r->handler = handler;
+	    cbdataLock(data);
+	    r->data = data;
+	    r->auth_user_request = auth_user_request;
+	    if (server == NULL) {
+		helperStatefulSubmit(ntlmauthenticators, NULL, authenticateNTLMHandleplaceholder, r, ntlm_request->authhelper);
+	    } else {
+		snprintf(buf, 8192, "YR\n");
+		helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
 	    }
-	}
-      else
-	{
-	  /* we have a valid challenge */
-	  /* TODO: turn the below into a function and call from here and handlereply */
-	  /* increment the challenge uses */
-	  helperstate->challengeuses++;
-	  /* assign the challenge */
-	  ntlm_request->authchallenge = xstrndup (helperstate->challenge, NTLM_CHALLENGE_SZ + 5);
-	  handler (data, NULL);
+	} else {
+	    /* we have a valid challenge */
+	    /* TODO: turn the below into a function and call from here and handlereply */
+	    /* increment the challenge uses */
+	    helperstate->challengeuses++;
+	    /* assign the challenge */
+	    ntlm_request->authchallenge = xstrndup(helperstate->challenge, NTLM_CHALLENGE_SZ + 5);
+	    handler(data, NULL);
 	}
 
-      break;
+	break;
     case AUTHENTICATE_STATE_RESPONSE:
-      r = CBDATA_ALLOC (authenticateStateData, NULL);
-      r->handler = handler;
-      cbdataLock (data);
-      r->data = data;
-      r->auth_user_request = auth_user_request;
-      snprintf (buf, 8192, "KK %s\n", sent_string);
-      helperStatefulSubmit (ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
-      debug (29, 9) ("authenticateNTLMstart: finished\n");
-      break;
+	r = CBDATA_ALLOC(authenticateStateData, NULL);
+	r->handler = handler;
+	cbdataLock(data);
+	r->data = data;
+	r->auth_user_request = auth_user_request;
+	snprintf(buf, 8192, "KK %s\n", sent_string);
+	helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
+	debug(29, 9) ("authenticateNTLMstart: finished\n");
+	break;
     default:
-      fatal ("Invalid authenticate state for NTLMStart");
+	fatal("Invalid authenticate state for NTLMStart");
     }
 #endif
 }
 
 /* callback used by stateful helper routines */
 int
-authenticateNTLMHelperServerAvailable (void *data)
+authenticateNTLMHelperServerAvailable(void *data)
 {
-  ntlm_helper_state_t *statedata = data;
-  if (statedata != NULL)
-    {
-      if (statedata->starve)
-	{
-	  debug (29, 4) ("authenticateNTLMHelperServerAvailable: starving - returning 0\n");
-	  return 0;
-	}
-      else
-	{
-	  debug (29, 4) ("authenticateNTLMHelperServerAvailable: not starving - returning 1\n");
-	  return 1;
+    ntlm_helper_state_t *statedata = data;
+    if (statedata != NULL) {
+	if (statedata->starve) {
+	    debug(29, 4) ("authenticateNTLMHelperServerAvailable: starving - returning 0\n");
+	    return 0;
+	} else {
+	    debug(29, 4) ("authenticateNTLMHelperServerAvailable: not starving - returning 1\n");
+	    return 1;
 	}
     }
-  debug (29, 4) ("authenticateNTLMHelperServerAvailable: no state data - returning 0\n");
-  return 0;
+    debug(29, 4) ("authenticateNTLMHelperServerAvailable: no state data - returning 0\n");
+    return 0;
 }
 
 void
-authenticateNTLMHelperServerOnEmpty (void *data)
+authenticateNTLMHelperServerOnEmpty(void *data)
 {
-  ntlm_helper_state_t *statedata = data;
-  if (statedata == NULL)
-    return;
-  if (statedata->starve)
-    {
-      /* we have been starving the helper */
-      debug (29, 9) ("authenticateNTLMHelperServerOnEmpty: resetting challenge details\n");
-      statedata->starve = 0;
-      statedata->challengeuses = 0;
-      statedata->renewed = 0;
-      xfree (statedata->challenge);
-      statedata->challenge = NULL;
+    ntlm_helper_state_t *statedata = data;
+    if (statedata == NULL)
+	return;
+    if (statedata->starve) {
+	/* we have been starving the helper */
+	debug(29, 9) ("authenticateNTLMHelperServerOnEmpty: resetting challenge details\n");
+	statedata->starve = 0;
+	statedata->challengeuses = 0;
+	statedata->renewed = 0;
+	xfree(statedata->challenge);
+	statedata->challenge = NULL;
     }
 }
 
 
 /* clear the NTLM helper of being reserved for future requests */
 void
-authenticateNTLMReleasehelper (auth_user_request_t * auth_user_request)
+authenticateNTLMReleasehelper(auth_user_request_t * auth_user_request)
 {
-  ntlm_request_t *ntlm_request;
-  assert (auth_user_request->auth_user->auth_type == AUTH_NTLM);
-  assert (auth_user_request->scheme_data != NULL);
-  ntlm_request = auth_user_request->scheme_data;
-  debug (29, 9) ("authenticateNTLMReleasehelper: releasing helper '%d'\n", ntlm_request->authhelper);
-  helperStatefulReleaseServer (ntlm_request->authhelper);
-  ntlm_request->authhelper = NULL;
+    ntlm_request_t *ntlm_request;
+    assert(auth_user_request->auth_user->auth_type == AUTH_NTLM);
+    assert(auth_user_request->scheme_data != NULL);
+    ntlm_request = auth_user_request->scheme_data;
+    debug(29, 9) ("authenticateNTLMReleasehelper: releasing helper '%d'\n", ntlm_request->authhelper);
+    helperStatefulReleaseServer(ntlm_request->authhelper);
+    ntlm_request->authhelper = NULL;
 }
 
 /* clear any connection related authentication details */
 void
-authenticateNTLMOnCloseConnection (ConnStateData * conn)
+authenticateNTLMOnCloseConnection(ConnStateData * conn)
 {
-  ntlm_request_t *ntlm_request;
-  assert (conn != NULL);
-  if (conn->auth_user_request != NULL)
-    {
-      assert (conn->auth_user_request->scheme_data != NULL);
-      ntlm_request = conn->auth_user_request->scheme_data;
-      if (ntlm_request->authhelper != NULL)
-	authenticateNTLMReleasehelper (conn->auth_user_request);
-      /* unlock the connection based lock */
-      debug (29, 9) ("authenticateNTLMOnCloseConnection: Unlocking auth_user from the connection.\n");
-      authenticateAuthUserRequestUnlock (conn->auth_user_request);
-      conn->auth_user_request = NULL;
+    ntlm_request_t *ntlm_request;
+    assert(conn != NULL);
+    if (conn->auth_user_request != NULL) {
+	assert(conn->auth_user_request->scheme_data != NULL);
+	ntlm_request = conn->auth_user_request->scheme_data;
+	if (ntlm_request->authhelper != NULL)
+	    authenticateNTLMReleasehelper(conn->auth_user_request);
+	/* unlock the connection based lock */
+	debug(29, 9) ("authenticateNTLMOnCloseConnection: Unlocking auth_user from the connection.\n");
+	authenticateAuthUserRequestUnlock(conn->auth_user_request);
+	conn->auth_user_request = NULL;
     }
 }
 
 /* authenticateUserUsername: return a pointer to the username in the */
 char *
-authenticateNTLMUsername (auth_user_t * auth_user)
+authenticateNTLMUsername(auth_user_t * auth_user)
 {
-  ntlm_user_t *ntlm_user = auth_user->scheme_data;
-  if (ntlm_user)
-    return ntlm_user->username;
-  return NULL;
+    ntlm_user_t *ntlm_user = auth_user->scheme_data;
+    if (ntlm_user)
+	return ntlm_user->username;
+    return NULL;
 }
 
 
